       IDENTIFICATION DIVISION.
       PROGRAM-ID.    ESD128C1.
       AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2019 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any non-commercial purpose and without fee is hereby      *
      * granted, provided the SimoTime copyright notice appear on all *
      * copies of the software. The SimoTime name or Logo may not be  *
      * used in any advertising or publicity pertaining to the use    *
      * of the software without the written permission of SimoTime    *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any expressed or implied warranty,   *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *                                                               *
      *****************************************************************
      *      This program is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *                                                               *
      *                                   Record    Record     Key    *
      *  Function  Name     Organization  Format    Max-Min  Pos-Len  *
      *  INPUT     ESD080RS SEQUENTIAL    FIXED      00080            *
      *  OUTPUT    ESD128D1 SEQUENTIAL    FIXED      00128            *
      *                                                               *
      *****************************************************************
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT ESD080RS-FILE ASSIGN     ESD080RS
                  ORGANIZATION  IS SEQUENTIAL
                  ACCESS MODE   IS SEQUENTIAL
                  FILE STATUS   IS ESD080RS-STATUS.
           SELECT ESD128D1-FILE ASSIGN     ESD128D1
                  ORGANIZATION  IS SEQUENTIAL
                  ACCESS MODE   IS SEQUENTIAL
                  FILE STATUS   IS ESD128D1-STATUS.

      *****************************************************************
       DATA DIVISION.
       FILE SECTION.
       FD  ESD080RS-FILE
           DATA RECORD    IS ESD080RS-REC
           RECORDING MODE IS F
           .
       01  ESD080RS-REC.
           05  ESD080RS-DATA-01 PIC X(80).

       FD  ESD128D1-FILE
           DATA RECORD    IS ESD128D1-REC
           RECORDING MODE IS V
           RECORD VARYING FROM 00001 TO 00128
           DEPENDING ON ESD128D1-LRECL
           .
       01  ESD128D1-REC.
           05  ESD128D1-DATA-01 PIC X(00128).

      *****************************************************************
      * This program was created using the SYSMASK3.TXT file as the   *
      * template for the File I/O. It is intended for use with the    *
      * TransCALL facility that makes a call to a routine that does   *
      * the actual conversion between EBCDIC and ASCII. For more      *
      * information or questions contact SimoTime Technologies.       *
      *                                                               *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *                                                               *
      * The SYSMASK3 provides for the sequential reading of the input *
      * file and the sequential writing of the output file.           *
      * If the output file is indexed then the input file must be in  *
      * sequence by the field that will be used to provide the key    *
      * for the output file.                                          *
      *                                                               *
      * If the key field is not in sequence then refer to SYSMASK4    *
      * to provide for a random add or update of the indexed file.    *
      *****************************************************************
       WORKING-STORAGE SECTION.
       01  SIM-TITLE.
           05  T1 pic X(11) value '* ESD128C1 '.
           05  T2 pic X(34) value 'Get Record Sequential, Extend ESDS'.
           05  T3 pic X(10) value ' v08.02.15'.
           05  T4 pic X(24) value ' http://www.simotime.com'.
       01  SIM-COPYRIGHT.
           05  C1 pic X(11) value '* ESD128C1 '.
           05  C2 pic X(20) value 'Copyright 1987-2019 '.
           05  C3 pic X(28) value '   SimoTime Technologies    '.
           05  C4 pic X(20) value ' All Rights Reserved'.

       01  ESD080RS-STATUS.
           05  ESD080RS-STATUS-L     pic X.
           05  ESD080RS-STATUS-R     pic X.
       01  ESD080RS-EOF              pic X       value 'N'.
       01  ESD080RS-OPEN-FLAG        pic X       value 'C'.

       01  ESD128D1-STATUS.
           05  ESD128D1-STATUS-L     pic X.
           05  ESD128D1-STATUS-R     pic X.
       01  ESD128D1-EOF              pic X       value 'N'.
       01  ESD128D1-OPEN-FLAG        pic X       value 'C'.

       01  ESD080RS-LRECL    pic 9(5)    value 00080.
       01  ESD128D1-LRECL    pic 9(5)    value 00128.

      *****************************************************************
      * The following buffers are used to create a four-byte status   *
      * code that may be displayed.                                   *
      *****************************************************************
       01  IO-STATUS.
           05  IO-STAT1            pic X.
           05  IO-STAT2            pic X.
       01  IO-STATUS-04.
           05  IO-STATUS-0401      pic 9     value 0.
           05  IO-STATUS-0403      pic 999   value 0.
       01  TWO-BYTES-BINARY        pic 9(4)  BINARY.
       01  TWO-BYTES-ALPHA         redefines TWO-BYTES-BINARY.
           05  TWO-BYTES-LEFT      pic X.
           05  TWO-BYTES-RIGHT     pic X.

      *****************************************************************
      * Message Buffer used by the Z-DISPLAY-MESSAGE-TEXT routine.    *
      *****************************************************************
       01  MESSAGE-BUFFER.
           05  MESSAGE-HEADER      pic X(11)   value '* ESD128C1 '.
           05  MESSAGE-TEXT.
               10  MESSAGE-TEXT-1  pic X(68)   value SPACES.
               10  MESSAGE-TEXT-2  pic X(188)  value SPACES.

      *****************************************************************
       01  PROGRAM-NAME            pic X(8)     value 'ESD128C1'.

       01  APPL-RESULT             pic S9(9)    comp.
           88  APPL-AOK            value 0.
           88  APPL-EOF            value 16.

       01  ESD080RS-TOTAL.
           05  ESD080RS-RDR pic 9(9)   value 0.
           05  filler       pic X(3)   value ' - '.
           05  filler       pic X(23)  value 'Line count for ESD080RS'.
       01  ESD128D1-TOTAL.
           05  ESD128D1-ADD pic 9(9)   value 0.
           05  filler       pic X(3)   value ' - '.
           05  filler       pic X(23)  value 'Line count for ESD128D1'.

      *****************************************************************
       PROCEDURE DIVISION.
           perform Z-POST-COPYRIGHT
           perform ESD080RS-OPEN
           perform ESD128D1-OPEN

           perform until ESD080RS-STATUS not = '00'
               perform ESD080RS-READ
               if  ESD080RS-STATUS = '00'
                   add 1 to ESD080RS-RDR
                   perform BUILD-OUTPUT-RECORD
                   perform ESD128D1-WRITE
                   if  ESD128D1-STATUS = '00'
                       add 1 to ESD128D1-ADD
                   end-if
               end-if
           end-perform

           move ESD080RS-TOTAL to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT

           move ESD128D1-TOTAL to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT

           if  APPL-EOF
               move 'is Complete...' to MESSAGE-TEXT
           else
               move 'is ABENDING...' to MESSAGE-TEXT
           end-if
           perform Z-DISPLAY-MESSAGE-TEXT

           perform ESD128D1-CLOSE
           perform ESD080RS-CLOSE
           GOBACK.

      *****************************************************************
       BUILD-OUTPUT-RECORD.
      *>   TransINIT process...
           move ALL SPACES to ESD128D1-REC
      *>   TransCOPY...
           move ESD080RS-REC(00001:00080) to ESD128D1-REC(00001:00080)
           display ESD128D1-REC(00001:00080) upon console
           display 'Record Length=' ESD128D1-LRECL upon console
           exit.

      *****************************************************************
      * I/O Routines for the INPUT File...                            *
      *****************************************************************
       ESD080RS-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close ESD080RS-FILE
           if  ESD080RS-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'CLOSE Failure with ESD080RS' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move ESD080RS-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       ESD080RS-READ.
           read ESD080RS-FILE
           if  ESD080RS-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  ESD080RS-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if
           if  APPL-AOK
               CONTINUE
           else
               if  APPL-EOF
                   move 'Y' to ESD080RS-EOF
               else
                   move 'READ Failure with ESD080RS' to MESSAGE-TEXT
                   perform Z-DISPLAY-MESSAGE-TEXT
                   move ESD080RS-STATUS to IO-STATUS
                   perform Z-DISPLAY-IO-STATUS
                   perform Z-ABEND-PROGRAM
               end-if
           end-if
           exit.
      *---------------------------------------------------------------*
       ESD080RS-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open input ESD080RS-FILE
           if  ESD080RS-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to ESD080RS-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'OPEN Failure with ESD080RS' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move ESD080RS-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * I/O Routines for the OUTPUT File...                           *
      *****************************************************************
       ESD128D1-WRITE.
           if  ESD128D1-OPEN-FLAG = 'C'
               perform ESD128D1-OPEN
           end-if
           write ESD128D1-REC
           if  ESD128D1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  ESD128D1-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if.
           if  APPL-AOK
               CONTINUE
           else
               move 'WRITE Failure with ESD128D1' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move ESD128D1-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       ESD128D1-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open EXTEND ESD128D1-FILE
           if  ESD128D1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to ESD128D1-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'OPEN Failure with ESD128D1' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move ESD128D1-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       ESD128D1-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close ESD128D1-FILE
           if  ESD128D1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'C' to ESD128D1-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'CLOSE Failure with ESD128D1' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move ESD128D1-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * The following Z-ROUTINES provide administrative functions     *
      * for this program.                                             *
      *****************************************************************
      * ABEND the program, post a message to the console and issue    *
      * a STOP RUN.                                                   *
      *****************************************************************
       Z-ABEND-PROGRAM.
           if  MESSAGE-TEXT not = SPACES
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           move 'PROGRAM-IS-ABENDING...'  to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT
           add 12 to ZERO giving RETURN-CODE
           STOP RUN.
      *    exit.

      *****************************************************************
      * Display CONSOLE messages...                                   *
      *****************************************************************
       Z-DISPLAY-MESSAGE-TEXT.
           if MESSAGE-TEXT-2 = SPACES
               display MESSAGE-BUFFER(1:79)
           else
               display MESSAGE-BUFFER
           end-if
           move all SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
      * Display the file status bytes. This routine will display as   *
      * four digits. If the full two byte file status is numeric it   *
      * will display as 00nn. If the 1st byte is a numeric nine (9)   *
      * the second byte will be treated as a binary number and will   *
      * display as 9nnn.                                              *
      *****************************************************************
       Z-DISPLAY-IO-STATUS.
           if  IO-STATUS not NUMERIC
           or  IO-STAT1 = '9'
               move IO-STAT1 to IO-STATUS-04(1:1)
               subtract TWO-BYTES-BINARY from TWO-BYTES-BINARY
               move IO-STAT2 to TWO-BYTES-RIGHT
               add TWO-BYTES-BINARY to ZERO giving IO-STATUS-0403
               move 'File Status is: nnnn' to MESSAGE-TEXT
               move IO-STATUS-04 to MESSAGE-TEXT(17:4)
               perform Z-DISPLAY-MESSAGE-TEXT
           else
               move '0000' to IO-STATUS-04
               move IO-STATUS to IO-STATUS-04(3:2)
               move 'File Status is: nnnn' to MESSAGE-TEXT
               move IO-STATUS-04 to MESSAGE-TEXT(17:4)
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           exit.

      *****************************************************************
       Z-POST-COPYRIGHT.
           display SIM-TITLE
           display SIM-COPYRIGHT
           exit.
      *****************************************************************
      *           This program was generated by SimoZAPS              *
      *             A product of SimoTime Technologies                *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *                                                               *
      *  Generation Date: 2008-04-30  Generation Time: 21:36:34:64    *
      *****************************************************************
